/*
	$Id: Text.h,v 1.1 2000/10/03 18:45:22 syl Exp $

	Copyright (C) 1999, 2000 Syllabub
	Maroontress Fast Software.
*/

typedef struct {
    wchar_t *wcs; /* 磻ɥ饯ʸ */
    int len;      /* ʸ */
    int eol;      /* End Of Line (True or False) */
} SylText;

#define LengthOfSylText(t) ((t)->len)
#define EndOfLineSylText(t) ((t)->eol)

SylText * CreateSylTextFromMBString(char *mbs, int eol);
SylText * CreateSylTextFromWCString(wchar_t *wcs, int eol);
void FreeSylText(SylText *txt);
wchar_t * CreateWCStringFromSylText(SylText *txt, int bgn, int end);
char * CreateMBStringFromSylText(SylText *txt, int bgn, int end);
void InsertWCharIntoSylText(SylText *txt, int n, wchar_t c);
void InsertWCStringIntoSylText(SylText *txt, int n, wchar_t *p);
void DeleteWCharOfSylText(SylText *txt, int n);
void DeleteWCStringOfSylText(SylText *txt, int bgn, int end);
void ChangeEndOfLineSylText(SylText *txt, int eol);
int CompareSylText(SylText *, SylText *);

SylText * ConcatAndCreateSylText(SylText *head, SylText *tail);
void SplitAndCreateSylTexts(SylText *txt, int n, int eol,
			    SylText **head, SylText **tail);
